diff --git a/base/kra/src/com/netscape/kra/NetkeyKeygenService.java b/base/kra/src/com/netscape/kra/NetkeyKeygenService.java
index 3acea9ae11300c1e63cf6a93b9a79c2d71fdeb5a..da0db1a6a6702b4f5a2236c1ec6d72b3cf30cad6 100644
--- a/base/kra/src/com/netscape/kra/NetkeyKeygenService.java
+++ b/base/kra/src/com/netscape/kra/NetkeyKeygenService.java
@@ -176,7 +176,7 @@ public class NetkeyKeygenService implements IService {
                         tp = true;
                         sp = false;
                         ep = true;
-                    } else   
+                    } else
                         tp = true;
                     }
             } catch (Exception e) {
@@ -270,7 +270,7 @@ public class NetkeyKeygenService implements IService {
                     // 602548 NSS bug - to overcome it, we use isBadDSAKeyPair
                     kp = kpGen.genKeyPair();
                 }
-                while (isBadDSAKeyPair(kp)); 
+                while (isBadDSAKeyPair(kp));
                 */
                 return kp;
             }
@@ -312,18 +312,18 @@ public class NetkeyKeygenService implements IService {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     // this encrypts bytes with a symmetric key
@@ -443,7 +443,7 @@ public class NetkeyKeygenService implements IService {
             CMS.debug("NetkeyKeygenService: failed getting keygenToken");
             request.setExtData(IRequest.RESULT, Integer.valueOf(10));
             return false;
-        } else 
+        } else
             CMS.debug("NetkeyKeygenService: got keygenToken");
 
         if ((wrapped_des_key != null) &&
@@ -659,7 +659,7 @@ public class NetkeyKeygenService implements IService {
                             oidDescription);
 
                         rec.set(IKeyRecord.ATTR_META_INFO, metaInfo);
-                        // key size does not apply to EC; 
+                        // key size does not apply to EC;
                         rec.setKeySize(-1);
                     }
 
diff --git a/base/kra/src/com/netscape/kra/TokenKeyRecoveryService.java b/base/kra/src/com/netscape/kra/TokenKeyRecoveryService.java
index 6ce8d11a44fa197a24f14714947ea179a9ed0bee..c7228e2f9217e2f5568adad727d05a16dc2eba3b 100644
--- a/base/kra/src/com/netscape/kra/TokenKeyRecoveryService.java
+++ b/base/kra/src/com/netscape/kra/TokenKeyRecoveryService.java
@@ -154,18 +154,18 @@ public class TokenKeyRecoveryService implements IService {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     // this encrypts bytes with a symmetric key
diff --git a/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java b/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
index 836907dac66c52f6f539c57585e9daadf7e0812b..eb9060663c0ff5336cf7d4d0736b6d6284d2ae49 100644
--- a/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
+++ b/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
@@ -429,8 +429,7 @@ public class OCSPAuthority implements IOCSPAuthority, IOCSPService, ISubsystem,
      */
     public BasicOCSPResponse sign(ResponseData rd)
             throws EBaseException {
-        try {
-            DerOutputStream out = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
             DerOutputStream tmp = new DerOutputStream();
 
             String algname = mSigningUnit.getDefaultAlgorithm();
diff --git a/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java b/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
index 81378ac1a428f71c4d1cf1bef1d098092f2c089c..b173055256b729954394e673ecfc929cde2f7965 100644
--- a/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
+++ b/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
@@ -379,16 +379,18 @@ public class CryptoUtil {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)));
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public static byte[] base64Decode(String s) throws IOException {
@@ -824,7 +826,6 @@ public class CryptoUtil {
         CryptoToken token = priKey.getOwningToken();
 
         DerOutputStream tmp = new DerOutputStream();
-        DerOutputStream out = new DerOutputStream();
 
         certInfo.encode(tmp);
         Signature signer = token.getSignatureContext(sigAlg);
@@ -835,10 +836,14 @@ public class CryptoUtil {
 
         aid.encode(tmp);
         tmp.putBitString(signed);
-        out.write(DerValue.tag_Sequence, tmp);
-        X509CertImpl signedCert = new X509CertImpl(out.toByteArray());
+        try (DerOutputStream out = new DerOutputStream()) {
+            out.write(DerValue.tag_Sequence, tmp);
+            X509CertImpl signedCert = new X509CertImpl(out.toByteArray());
+            return signedCert;
+        } catch (CertificateException | IOException e) {
+            throw e;
+        }
 
-        return signedCert;
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/AccessDescription.java b/base/util/src/netscape/security/extensions/AccessDescription.java
index f13c937e7ea7995c7e9ace5d5827b6e01cb888d5..f42f3b7f81da78fdb0c2642083c8449a5e50f38d 100644
--- a/base/util/src/netscape/security/extensions/AccessDescription.java
+++ b/base/util/src/netscape/security/extensions/AccessDescription.java
@@ -49,13 +49,16 @@ public class AccessDescription implements Serializable {
      */
     private void writeObject(java.io.ObjectOutputStream out)
             throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream();
+             DerOutputStream tmp = new DerOutputStream()) {
 
-        tmp.putOID(mOID);
-        mLocation.encode(tmp);
-        seq.write(DerValue.tag_Sequence, tmp);
-        out.write(seq.toByteArray());
+            tmp.putOID(mOID);
+            mLocation.encode(tmp);
+            seq.write(DerValue.tag_Sequence, tmp);
+            out.write(seq.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/AuthInfoAccessExtension.java b/base/util/src/netscape/security/extensions/AuthInfoAccessExtension.java
index 15c56a04cbce669ae04c9cc26aa000b498389082..800252cebee5385386f33ff0571c41888a4abd50 100644
--- a/base/util/src/netscape/security/extensions/AuthInfoAccessExtension.java
+++ b/base/util/src/netscape/security/extensions/AuthInfoAccessExtension.java
@@ -184,19 +184,22 @@ public class AuthInfoAccessExtension extends Extension implements CertAttrSet {
     }
 
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream();
+             DerOutputStream tmp = new DerOutputStream()) {
 
-        for (int i = 0; i < mDesc.size(); i++) {
-            DerOutputStream tmp0 = new DerOutputStream();
-            AccessDescription ad = mDesc.elementAt(i);
+            for (int i = 0; i < mDesc.size(); i++) {
+                DerOutputStream tmp0 = new DerOutputStream();
+                AccessDescription ad = mDesc.elementAt(i);
 
-            tmp0.putOID(ad.getMethod());
-            ad.getLocation().encode(tmp0);
-            tmp.write(DerValue.tag_Sequence, tmp0);
+                tmp0.putOID(ad.getMethod());
+                ad.getLocation().encode(tmp0);
+                tmp.write(DerValue.tag_Sequence, tmp0);
+            }
+            seq.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        seq.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/CertificateRenewalWindowExtension.java b/base/util/src/netscape/security/extensions/CertificateRenewalWindowExtension.java
index 14195945118a1649c025eebcb1f67dcf62b74338..0d0a1ce5309791d1ed763062a4648d8ad40955d8 100644
--- a/base/util/src/netscape/security/extensions/CertificateRenewalWindowExtension.java
+++ b/base/util/src/netscape/security/extensions/CertificateRenewalWindowExtension.java
@@ -148,15 +148,18 @@ public class CertificateRenewalWindowExtension extends Extension
     }
 
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream();
+             DerOutputStream tmp = new DerOutputStream()) {
 
-        tmp.putGeneralizedTime(mBeginTime);
-        if (mEndTime != null) {
-            tmp.putGeneralizedTime(mEndTime);
+            tmp.putGeneralizedTime(mBeginTime);
+            if (mEndTime != null) {
+                tmp.putGeneralizedTime(mEndTime);
+            }
+            seq.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        seq.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/CertificateScopeOfUseExtension.java b/base/util/src/netscape/security/extensions/CertificateScopeOfUseExtension.java
index 0f93c2b7801567d94368716ad8830727caca4f34..350fb5365bb248d679b863da453ed41275b01fd0 100644
--- a/base/util/src/netscape/security/extensions/CertificateScopeOfUseExtension.java
+++ b/base/util/src/netscape/security/extensions/CertificateScopeOfUseExtension.java
@@ -147,20 +147,23 @@ public class CertificateScopeOfUseExtension extends Extension
     }
 
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream();
+             DerOutputStream tmp = new DerOutputStream()) {
 
-        if (mEntries == null)
-            throw new IOException("Invalid Scope Entries");
+            if (mEntries == null)
+                throw new IOException("Invalid Scope Entries");
 
-        for (int i = 0; i < mEntries.size(); i++) {
-            CertificateScopeEntry se = mEntries.elementAt(i);
+            for (int i = 0; i < mEntries.size(); i++) {
+                CertificateScopeEntry se = mEntries.elementAt(i);
 
-            se.encode(tmp);
+                se.encode(tmp);
+            }
+
+            seq.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-
-        seq.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java b/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
index 2ccc53ffd22ecedd28f12e6b87fd8cac288956ad..85f23b30ba9761cf48c0cd7f0a2c3bad11a1421c 100644
--- a/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
+++ b/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
@@ -152,21 +152,24 @@ public class InhibitAnyPolicyExtension
     }
 
     public void encode(OutputStream out) throws IOException {
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream os = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        if (this.extensionValue == null) {
-            try {
-                extensionId = ObjectIdentifier.getObjectIdentifier(OID);
-            } catch (IOException e) {
-                // never here
+            if (this.extensionValue == null) {
+                try {
+                    extensionId = ObjectIdentifier.getObjectIdentifier(OID);
+                } catch (IOException e) {
+                    // never here
+                }
+                os.putInteger(mSkipCerts);
+                this.extensionValue = os.toByteArray();
             }
-            DerOutputStream os = new DerOutputStream();
-            os.putInteger(mSkipCerts);
-            this.extensionValue = os.toByteArray();
-        }
 
-        super.encode(tmp);
-        out.write(tmp.toByteArray());
+            super.encode(tmp);
+            out.write(tmp.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     private void encodeExtValue() {
diff --git a/base/util/src/netscape/security/extensions/KerberosName.java b/base/util/src/netscape/security/extensions/KerberosName.java
index a10d70b40dd7ab4bc3fb9c50cf0389965603c0f7..a0549b047fb41153fee7cf22e26e86bd01844358 100644
--- a/base/util/src/netscape/security/extensions/KerberosName.java
+++ b/base/util/src/netscape/security/extensions/KerberosName.java
@@ -69,34 +69,37 @@ public class KerberosName {
      */
     public void encode(OutputStream out) throws IOException {
 
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
-        DerOutputStream realm = new DerOutputStream();
-        realm.putGeneralString(m_realm);
-        tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, (byte) 0), realm);
+        try (DerOutputStream seq = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
+            DerOutputStream realm = new DerOutputStream();
+            realm.putGeneralString(m_realm);
+            tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT,
+                    true, (byte) 0), realm);
 
-        DerOutputStream seq1 = new DerOutputStream();
-        DerOutputStream tmp1 = new DerOutputStream();
-        DerOutputStream name_type = new DerOutputStream();
-        name_type.putInteger(new BigInt(m_name_type));
-        tmp1.write(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, (byte) 0), name_type);
+            DerOutputStream seq1 = new DerOutputStream();
+            DerOutputStream tmp1 = new DerOutputStream();
+            DerOutputStream name_type = new DerOutputStream();
+            name_type.putInteger(new BigInt(m_name_type));
+            tmp1.write(DerValue.createTag(DerValue.TAG_CONTEXT,
+                    true, (byte) 0), name_type);
 
-        DerOutputStream name_strings = new DerOutputStream();
-        DerOutputStream name_string = new DerOutputStream();
-        for (int i = 0; i < m_name_strings.size(); i++) {
-            name_string.putGeneralString(m_name_strings.elementAt(i));
+            DerOutputStream name_strings = new DerOutputStream();
+            DerOutputStream name_string = new DerOutputStream();
+            for (int i = 0; i < m_name_strings.size(); i++) {
+                name_string.putGeneralString(m_name_strings.elementAt(i));
+            }
+            name_strings.write(DerValue.tag_SequenceOf, name_string);
+            tmp1.write(DerValue.createTag(DerValue.TAG_CONTEXT,
+                    true, (byte) 1), name_strings);
+            seq1.write(DerValue.tag_Sequence, tmp1);
+            tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT,
+                    true, (byte) 1), seq1);
+
+            seq.write(DerValue.tag_Sequence, tmp);
+            out.write(seq.toByteArray());
+        } catch (IOException e) {
+            throw e;
         }
-        name_strings.write(DerValue.tag_SequenceOf, name_string);
-        tmp1.write(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, (byte) 1), name_strings);
-        seq1.write(DerValue.tag_Sequence, tmp1);
-        tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, (byte) 1), seq1);
-
-        seq.write(DerValue.tag_Sequence, tmp);
-        out.write(seq.toByteArray());
     }
 
     public byte[] toByteArray() throws IOException {
diff --git a/base/util/src/netscape/security/extensions/NSCertTypeExtension.java b/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
index 1a240f1ce3d0221792741e9191e307549761fa8a..8018cf2d36b2849dce3db24d6e0a12814371701e 100644
--- a/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
+++ b/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
@@ -135,10 +135,13 @@ public class NSCertTypeExtension extends Extension implements CertAttrSet {
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream os = new DerOutputStream();
+        try (DerOutputStream os = new DerOutputStream()) {
 
-        os.putUnalignedBitString(mBitString);
-        this.extensionValue = os.toByteArray();
+            os.putUnalignedBitString(mBitString);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/extensions/PresenceServerExtension.java b/base/util/src/netscape/security/extensions/PresenceServerExtension.java
index 5ee802468ec5aad6de9b32b44085e8447e72ea10..21bbeffa1db7ed5ffcd53a8048fa61b9f03d22bd 100644
--- a/base/util/src/netscape/security/extensions/PresenceServerExtension.java
+++ b/base/util/src/netscape/security/extensions/PresenceServerExtension.java
@@ -130,19 +130,22 @@ public class PresenceServerExtension extends Extension implements CertAttrSet {
     }
 
     public void encodeThis() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream temp = new DerOutputStream();
-        temp.putInteger(new BigInt(mVersion));
-        temp.putOctetString(mStreetAddress.getBytes());
-        temp.putOctetString(mTelephoneNumber.getBytes());
-        temp.putOctetString(mRFC822Name.getBytes());
-        temp.putOctetString(mID.getBytes());
-        temp.putOctetString(mHostName.getBytes());
-        temp.putInteger(new BigInt(mPortNumber));
-        temp.putInteger(new BigInt(mMaxUsers));
-        temp.putInteger(new BigInt(mServiceLevel));
-        out.write(DerValue.tag_Sequence, temp);
-        this.extensionValue = out.toByteArray();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream temp = new DerOutputStream();
+            temp.putInteger(new BigInt(mVersion));
+            temp.putOctetString(mStreetAddress.getBytes());
+            temp.putOctetString(mTelephoneNumber.getBytes());
+            temp.putOctetString(mRFC822Name.getBytes());
+            temp.putOctetString(mID.getBytes());
+            temp.putOctetString(mHostName.getBytes());
+            temp.putInteger(new BigInt(mPortNumber));
+            temp.putInteger(new BigInt(mMaxUsers));
+            temp.putInteger(new BigInt(mServiceLevel));
+            out.write(DerValue.tag_Sequence, temp);
+            this.extensionValue = out.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public void decodeThis() throws IOException {
diff --git a/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java b/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
index 72407d62eec7575b9b079af03f8dc08db20f921e..acb493d6cc250336c70bf2a0b54a82e26cd76ea8 100644
--- a/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
+++ b/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
@@ -166,19 +166,22 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
     }
 
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream();
+                DerOutputStream tmp = new DerOutputStream()) {
 
-        for (int i = 0; i < mDesc.size(); i++) {
-            DerOutputStream tmp0 = new DerOutputStream();
-            AccessDescription ad = mDesc.elementAt(i);
+            for (int i = 0; i < mDesc.size(); i++) {
+                DerOutputStream tmp0 = new DerOutputStream();
+                AccessDescription ad = mDesc.elementAt(i);
 
-            tmp0.putOID(ad.getMethod());
-            ad.getLocation().encode(tmp0);
-            tmp.write(DerValue.tag_Sequence, tmp0);
+                tmp0.putOID(ad.getMethod());
+                ad.getLocation().encode(tmp0);
+                tmp.write(DerValue.tag_Sequence, tmp0);
+            }
+            seq.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        seq.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/pkcs/PKCS10Attribute.java b/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
index c84df2a375beb1b858fb62e19f2d5988901deafd..5d3cfb8c825c6b343facda7a498635a655a97421 100644
--- a/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
+++ b/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
@@ -168,25 +168,28 @@ public class PKCS10Attribute implements DerEncoder, Serializable {
      */
     public void encode(OutputStream out)
             throws CertificateException, IOException {
-        // Encode the attribute value
-        DerOutputStream outAttrValue = new DerOutputStream();
-        attributeValue.encode(outAttrValue);
+        try (DerOutputStream tmp = new DerOutputStream()) {
+            // Encode the attribute value
+            DerOutputStream outAttrValue = new DerOutputStream();
+            attributeValue.encode(outAttrValue);
 
-        // Wrap the encoded attribute value into a SET
-        DerValue outAttrValueSet = new DerValue(DerValue.tag_Set,
-                        outAttrValue.toByteArray());
+            // Wrap the encoded attribute value into a SET
+            DerValue outAttrValueSet = new DerValue(DerValue.tag_Set,
+                    outAttrValue.toByteArray());
 
-        // Create the attribute
-        DerOutputStream outAttr = new DerOutputStream();
-        outAttr.putOID(attributeId);
-        outAttr.putDerValue(outAttrValueSet);
+            // Create the attribute
+            DerOutputStream outAttr = new DerOutputStream();
+            outAttr.putOID(attributeId);
+            outAttr.putDerValue(outAttrValueSet);
 
-        // Wrap the OID and the set of attribute values into a SEQUENCE
-        DerOutputStream tmp = new DerOutputStream();
-        tmp.write(DerValue.tag_Sequence, outAttr);
+            // Wrap the OID and the set of attribute values into a SEQUENCE
+            tmp.write(DerValue.tag_Sequence, outAttr);
 
-        // write the results to out
-        out.write(tmp.toByteArray());
+            // write the results to out
+            out.write(tmp.toByteArray());
+        } catch (CertificateException | IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/pkcs/PKCS10Attributes.java b/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
index 22a0dce21ddc6ca5b65ca770eda338c1d68fb851..4c972187f11848f0eed47640197f5714b48e3312 100644
--- a/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
+++ b/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
@@ -92,16 +92,18 @@ public class PKCS10Attributes extends Vector<PKCS10Attribute> implements DerEnco
      */
     public void derEncode(OutputStream out)
             throws IOException {
+        try (DerOutputStream attrOut = new DerOutputStream()) {
+            // first copy the elements into an array
+            PKCS10Attribute[] attribs = new PKCS10Attribute[size()];
+            copyInto(attribs);
 
-        // first copy the elements into an array
-        PKCS10Attribute[] attribs = new PKCS10Attribute[size()];
-        copyInto(attribs);
+            attrOut.putOrderedSetOf(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 0),
+                    attribs);
 
-        DerOutputStream attrOut = new DerOutputStream();
-        attrOut.putOrderedSetOf(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 0),
-                attribs);
-
-        out.write(attrOut.toByteArray());
+            out.write(attrOut.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
